from __future__ import print_function
# -*- coding: utf-8 -*-

_FonctionDuProgramme="Classe donnant accès aux interactions à N corps"
print(_FonctionDuProgramme)
_Version="3.0.1"
print("Version:"+_Version)

"""
3.0.1 ajout des conditions finales relatives aux initiales
3.0 réécriture des classes 

"""

#dossier="/home/bruno/Bureau/PROGRAMMATION/PYTHON/CLASSES"
dossier="/opt/CLASSES"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
    
import re








##################### debug


_debug_Titres=False # _debug_Titres=True #
_debug=False # _debug=True #
_debug_all=False # _debug_all=True # 

if _debug_all==True:
	_debug_Titres=True
	_debug=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+re.sub('.*/','',sys.argv[0])+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
		
def dprint(*args, **kwargs):
	if _debug==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
		print('--------------------------')
		
# # # # # # # # # # # # # # # # # # # debug











import CMatrixMatrices
from CMatrixMatrices import *
import CImages
from CImages import *


class CDonneesPhysiques(object):
	""" forces , positions, vitesses """
	def __init__(self,acc=["grav"]):# NbDeCorps=2,G=1.0,dt=1.0,UneCleToutesLesNFrames=1,NbDt=250):
		
		#self._accelerations=[]
		self._Cx=0.0 #frottement		
		self._hbar=1.0 #Js
		self._G=1.0 #grav  self._G=1.0 #grav
		self._c=1.0 #m/s	
		
		self._c=299792458.0
		self._G=6.67408E-11
		self._hbar=6.62607015E-34
		
		if "grav" in acc:
			self._accelerations=[self.accG]
			
		#self.ConditionsInitiales(1)
		
	def accG(self,r1,r2,masse2):#action de 2 sur 1
		""" gravitation : action de 2 sur 1 """		
		r=r1-r2
		a=-self._G/( r.Norme() )**3.0 * r * masse2
		dprint("..52..",r1,r2)
		dprint("..53..",self._G,r.Norme(),r,masse2)
		dprint("..54.a=.",a)
		return a

	def accF(self,v,masse):
		""" frottements : a = - Cx V /m  """
		a=-self._Cx*v / masse
		return a
	
	def ConditionsInitiales(self,NoDeLExperience=0,centre=True):
		""" INITIALISATION des masses, vitesses, positions , centrage sur le centre de gravité"""
		
		if NoDeLExperience==0:
			self._NbDeCorps=2
			self._points=[CPoint(no) for no in range(self._NbDeCorps)]
			masses=[10*1000*1000.0]+[1.0]*(self._NbDeCorps-1)
			for p in range(self._NbDeCorps):
				self._points[p]._masse=masses[p]
				self._points[p]._pos=Vecteur([-100.0*p,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
			self._points[0]._vit=Vecteur(3)#Vector((0.0,0.0,0.0))
			for p in range(1,self._NbDeCorps):
				self._points[p]._vit=Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[p]._pos).Norme() )**0.5,0.0])
			
		if NoDeLExperience==1:#surface de la Terre
			self._NbDeCorps=2
			self._points=[CPoint(no) for no in range(2)]
			masses=[6.0E24 , 1.0]			
			self._points[0]._pos=Vecteur([0.0,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
			self._points[0]._vit=Vecteur(3)#Vector((0.0,0.0,0.0))
			self._points[0]._masse=masses[0]
			
			self._points[1]._pos=Vecteur([0.0,0.0,6.371E6]) #Vector((-100.0*p,0.0,0.0))
			#self._points[1]._vit=Vecteur(3)#Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[p]._pos).Norme() )**0.5,0.0])
			self._points[1]._vit=Vecteur([0.0,0.0,10.0])
			self._points[1]._masse=masses[1]

		if NoDeLExperience==2:#départ de la Terre
			self._NbDeCorps=2
			self._points=[CPoint(no) for no in range(2)]
			masses=[6.0E24 , 1.0]			
			self._points[0]._pos=Vecteur([0.0,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
			self._points[0]._vit=Vecteur(3)#Vector((0.0,0.0,0.0))
			self._points[0]._masse=masses[0]
			
			self._points[1]._pos=Vecteur([0.0,0.0,6.371E6]) #Vector((-100.0*p,0.0,0.0))
			#self._points[1]._vit=Vecteur(3)#Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[p]._pos).Norme() )**0.5,0.0])
			self._points[1]._vit=Vecteur([0.0,0.0,20000.0])
			self._points[1]._masse=masses[1]


		#['f=', 65000, ';t=', 65000.0, ';pos(0)=', '[0.0;0.0;8.997148249737847e-17]', ';vit(0)=', '[0.0;0.0;1.5408261852931502e-21]', ';pos(1)=', '[0.0;0.0;188487306.15932888]', ';vit(1)=', '[0.0;0.0;1959.973350414843]', ';E=', '-1.3763317838311195e-05']
		if NoDeLExperience==3:#départ de la Terre
			d=['f=', 65000, ';t=', 65000.0, ';pos(0)=', '[0.0;0.0;8.997148249737847e-17]', ';vit(0)=', '[0.0;0.0;1.5408261852931502e-21]', ';pos(1)=', '[0.0;0.0;188487306.15932888]', ';vit(1)=', '[0.0;0.0;1959.973350414843]', ';E=', '-1.3763317838311195e-05']
			e= [  [float(i) for i in (d[j][1:len(d[j])-1]).split(";")] for j in range(5,12,2)]
			p0,v0,p1,v1=[Vecteur(e[i]) for i in range(4)]
			
			self._NbDeCorps=2
			self._points=[CPoint(no) for no in range(2)]
			masses=[6.0E24 , 1.0]			
			self._points[0]._pos=p0
			self._points[0]._vit=v0
			self._points[0]._masse=masses[0]
			
			self._points[1]._pos=p1
			#self._points[1]._vit=Vecteur(3)#Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[p]._pos).Norme() )**0.5,0.0])
			self._points[1]._vit=v1
			self._points[1]._masse=masses[1]
			
				

		if centre==True:#centrage sur le centre de gravité
			self.Centrage()
			
			
		self.Init_points=deepcopy(self._points)
		self.Init_Energie=self.Energie()
		
		print('energie initiale = ', self.Init_Energie)
		
	def Centrage(self):
		Pg , M	= Vecteur(3),0.0 # Vector((0.0,0.0,0.0)) , 0.0
		for p in range(self._NbDeCorps):
			Pg+=self._points[p]._masse*self._points[p]._vit
			M+=self._points[p]._masse
		Vg=Pg/M
		for p in range(self._NbDeCorps):
			self._points[p]._vit=self._points[p]._vit-Vg
			#print("vit["+str(p)+"]",self._points[p]._vit)

	def Energie(self):		
		return self.Ec()+self.EnergieG()
		
	def EnergieV(self):
		EV=0.0
		for pt in self._points:
			EV += pt.Ec()
		return EV
		
	def Ec(self):
		return self.EnergieV()
		
	def EnergieG(self):
		EG=0.0
		for i in range(self._NbDeCorps-1):
			pt1=self._points[i]
			for j in range(i+1,self._NbDeCorps):
				pt2=self._points[j]
				#EG += - (self._G) * (pt1._masse)*(pt2._masse) / ( (pt1._pos-pt2._pos).length )
				EG += - (self._G) * (pt1._masse)*(pt2._masse) / ( pt1._pos-pt2._pos).Norme() 
				#print('norme=',type(( pt1._pos-pt2._pos).Norme() ))
		return EG
		
	def RK4_XVT(self,i,j,dt):#Xinit, Vinit, a, dt):#a(x,v,dt)
		Xinit,Vinit = self._points[i]._pos , self._points[i]._vit
		
		Robj = self._points[j]._pos
		mobj = self._points[j]._masse
		acc=self.accG
		"""Returns final (position, velocity) tuple after
		time dt has passed.

		Xinit: initial position (number-like object)
		Vinit: initial velocity (number-like object)
		a: acceleration function a(x,v,dt) (must be callable)
		dt: timestep (number)"""
		x1 = Xinit
		v1 = Vinit
		a1 = acc(x1, Robj ,mobj)
		
		x2 = Xinit + 0.5*v1*dt
		
		v2 = Vinit + 0.5*a1*dt
		a2 = acc(x2, Robj,mobj)

		x3 = Xinit + 0.5*v2*dt
		v3 = Vinit + 0.5*a2*dt
		a3 = acc(x3, Robj,mobj)

		x4 = Xinit + v3*dt
		v4 = Vinit + a3*dt
		a4 = acc(x4, Robj,mobj)

		dxf = (dt/6.0)*(v1 + 2*v2 + 2*v3 + v4)
		dvf = (dt/6.0)*(a1 + 2*a2 + 2*a3 + a4)

		return dxf,dvf
					
	def Experience(self,fichier=[True,'/tmp/ee']):		
		#self._ibf={"fichier":fichier[0]}
		self._dt=1.0
		self._NbDt=int(4000)
		self._t=self._dt*self._NbDt		
		self._FICH_UneCleTousLesNPas=100
		self.initfichier(fichier)
	
	def initfichier(self,fichier):
		if True==True:#if self._ibf["fichier"]==True:
			self._fich=open('/tmp/ee','w')#open(fichier[1],"w")
			self._html=[]
			self._html+=["_dt=",self._dt]
			self._html+=["_NbDt=",self._NbDt]
			self._html+=["_t=",self._t]
			
			for h in self._html:
				print(h,file=self._fich)
			
			self._html=[]
						
	def Trajectoire(self):
		N=self._NbDeCorps
		self.EnregistreFrame(0,affiche=True)
		for f in range(1,self._NbDt+1):
			dprint('f=',f)
			self.NouveauPas()
			
			""" FICHIER """
			if f % self._FICH_UneCleTousLesNPas==0:# and self._ibf["fichier"]==True:
				#print('.',end="")
				self.EnregistreFrame(f,affiche=True)
				
				
	
	
				"""
				tmp=["f=",f]
				for i in range(N):
					tmp+=[";pos("+str(i)+")=",str(self._points[i]._pos-self.Init_points[i]._pos)]
					tmp+=[";vit("+str(i)+")=",str(self._points[i]._vit-self.Init_points[i]._vit)]
				self._html+=[tmp]		
				#print("---",self.Energie())
					#print("+++",self.Ec())
					#print("***",self.EnergieG())
					
				"""
				
			#print(self._DP._points[1]._pos.T())
			
		""" FICHIER 
		if True==True:#if self._ibf["fichier"]==True:
			for h in self._html:
				print(h,file=self._fich)
		"""	
		self._fich.close()	
		print('fin trajectoire')
	
	def EnregistreFrame(self,f,PosRel=True,VitRel=False,EnerRel=True,affiche=False):
		N=self._NbDeCorps
		tmp=["f=",f,";t=",f*self._dt]
		for i in range(N):
			tmp+=[";pos("+str(i)+")=",str(self._points[i]._pos-self.Init_points[i]._pos*(PosRel==True))]
			tmp+=[";vit("+str(i)+")=",str(self._points[i]._vit-self.Init_points[i]._vit*(VitRel==True))]
		tmp+=[";E=",str(self.Energie()-self.Init_Energie*(EnerRel==True))]
		
		print(tmp,file=self._fich)
		#['f=', 65000, ';t=', 65000.0, ';pos(0)=', '[0.0;0.0;8.997148249737847e-17]', ';vit(0)=', '[0.0;0.0;1.5408261852931502e-21]', ';pos(1)=', '[0.0;0.0;188487306.15932888]', ';vit(1)=', '[0.0;0.0;1959.973350414843]', ';E=', '-1.3763317838311195e-05']
			
		#self._html+=[tmp]
		
		if affiche==True:
			print(tmp)	
		
	def NouveauPas(self):
		N=self._NbDeCorps
		#dr=[Vector((0.0,0.0,0.0)) for i in range(N)]
		dr=[Vecteur([0.0,0.0,0.0]) for i in range(N)]
		#dv=[Vector((0.0,0.0,0.0)) for i in range(N)]  
		dv=[Vecteur([0.0,0.0,0.0]) for i in range(N)]  
		
		for i in range(N):
			for j in range(N):
				if i != j:
					#print(i,j)
					ddr,ddv=self.RK4_XVT(i,j,self._dt)#Xinit, Vinit, a, dt)
					#print(dr[i],dr)
					dr[i] += ddr
					dv[i] += ddv
			
		#print(ddr)
		
		self.NouveauxPoints(dr,dv) #calcule les nouveau point
		self.TransformePoints() # _NouveauxPoints-> _DP._points
		
	def NouveauxPoints(self,dr,dv):
		N=self._NbDeCorps
		self._NouveauxPoints=[CPoint(no) for no in range(N)]		
		for i in range(N):
			self._NouveauxPoints[i]._pos = self._points[i]._pos + dr[i]
			self._NouveauxPoints[i]._vit = self._points[i]._vit + dv[i]					
		return self._NouveauxPoints			
					
	def TransformePoints(self):
		N=self._NbDeCorps
		for i in range(N):
			self._points[i]._pos = self._NouveauxPoints[i]._pos
			self._points[i]._vit = self._NouveauxPoints[i]._vit

class CPoint(object):
	def __init__(self,no):
		self._no=no
		self._pos=Vecteur(3)# Vector((0.0,0.0,0.0))
		self._vit=Vecteur(3)# Vector((0.0,0.0,0.0))
		self._masse=1.0
		
		self._couleur=couleur(no)
				
		self._charge=0.0
		
		self._typeuh="point"#sphère/cube
		self._dimensions=Vecteur(3)# Vector((0.0,0.0,0.0))
		self._rotation=Vecteur(3)# Vector((0.0,0.0,0.0))

	def EnergieV(self):
		EV = 0.5*(self._masse)* ( (self._vit.T()*self._vit)._mat[0,0] )
		return EV
	
	def Ec(self):
		return self.EnergieV()

def couleur(i):
	col=[ (1.0,0.0,0.0),(0.0,1.0,0.0),(0.0,0.0,1.0),(1.0,1.0,0.0),(0.0,1.0,1.0),(1.0,0.0,1.0),(0.5,1.0,0.2)]
	return col[i % len(col)]



global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	z=CDonneesPhysiques(["grav"])

	z.ConditionsInitiales(2,False)

	z.Experience()
	
	z.Trajectoire()
	
	sys.exit()
