from __future__ import print_function
# -*- coding: utf-8 -*-

_FonctionDuProgramme="Classe donnant accès aux interactions à N corps"
print(_FonctionDuProgramme)
_Version="1.1"
print("Version:"+_Version)


#dossier="/home/bruno/Bureau/PROGRAMMATION/PYTHON/CLASSES"
dossier="/opt/CLASSES"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
    
import re


import CMatrixMatrices
from CMatrixMatrices import *



class CDonneesPhysiques(object):
	""" forces , positions, vitesses """
	def __init__(self,acc=["grav"]):# NbDeCorps=2,G=1.0,dt=1.0,UneCleToutesLesNFrames=1,NbDt=250):
			
		self._G=6.6E-11 #grav  self._G=1.0 #grav
		
		self._Cx=0.0 #frottement
		self._c=1.0 #m/s
		self._hbar=1.0 #Js
		self._accelerations=[]
		
		if "grav" in acc:
			self._accelerations+=[self.accG]
		
		self.INITIALISATION(1)

	def INITIALISATION(self,no=0,NbDeCorps=2,centre=True):
		""" INITIALISATION des masses, vitesses, positions """
		
		if no==0:
			self._NbDeCorps=NbDeCorps
			self._points=[CPoint(c) for c in range(self._NbDeCorps)]
			masses=[10*1000*1000.0]+[1.0]*(self._NbDeCorps-1)
			for p in range(self._NbDeCorps):
				self._points[p]._masse=masses[p]
				self._points[p]._pos=Vecteur([-100.0*p,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
			self._points[0]._vit=Vecteur(3)#Vector((0.0,0.0,0.0))
			for p in range(1,self._NbDeCorps):
				self._points[p]._vit=Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[p]._pos).Norme() )**0.5,0.0])
			
		if no==1:#surface terre
			self._NbDeCorps=2
			self._points=[CPoint(c) for c in range(2)]
			masses=[6.0E34 , 1.0]
			
			self._points[0]._pos=Vecteur([0.0,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
			self._points[0]._vit=Vecteur(3)#Vector((0.0,0.0,0.0))
			
			self._points[1]._pos=Vecteur([-6.600E6,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
			self._points[1]._vit=Vecteur(3)#Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[p]._pos).Norme() )**0.5,0.0])

		if centre==True:
			self.CENTRE()
				
	
	def CENTRE(self):
		Pg , M	= Vecteur(3),0.0 # Vector((0.0,0.0,0.0)) , 0.0
		for p in range(self._NbDeCorps):
			Pg+=self._points[p]._masse*self._points[p]._vit
			M+=self._points[p]._masse
		Vg=Pg/M
		for p in range(self._NbDeCorps):
			self._points[p]._vit=self._points[p]._vit-Vg
			#print("vit["+str(p)+"]",self._points[p]._vit)

	
	def EnergieV(self):
		EV=0.0
		for pt in self._points:
			EV+=0.5*pt._masse*(pt._vit)**2
		return EV
				
	def EnergieG(self):
		EG=0.0
		for i in range(self._NbDeCorps-1):
			pt1=self._points[i]
			for j in range(i+1,self._NbDeCorps):
				pt2=self._points[j]
				EG+=- self._G * pt1._masse*pt2._masse /((pt1._pos-pt2._pos).length)
		return EG
		
			
	def accG(self,r1,r2,masse2):#action de 2 sur 1
		""" gravitation : action de 2 sur 1 """		
		r=r1-r2
		a=-self._G/( r.Norme() )**3.0 * r * masse2
		print(a)
		
		"""
		print("r1",type(r1))
		print(type(r2))
		print(type(masse2))
		print("r",type(r))		
		print("a",type(a))
		"""
		return a
		
		
	def accF(self,v,masse):
		""" frottements : a = - Cx V /m  """
		a=-self._Cx*v / masse
		return a
					
	def RK4_XVT(self,i,j,dt):#Xinit, Vinit, a, dt):#a(x,v,dt)
		Xinit,Vinit = self._points[i]._pos , self._points[i]._vit
		
		Robj = self._points[j]._pos
		mobj = self._points[j]._masse
		acc=self.accG
		"""Returns final (position, velocity) tuple after
		time dt has passed.

		Xinit: initial position (number-like object)
		Vinit: initial velocity (number-like object)
		a: acceleration function a(x,v,dt) (must be callable)
		dt: timestep (number)"""
		x1 = Xinit
		v1 = Vinit
		a1 = acc(x1, Robj ,mobj)
		
		x2 = Xinit + 0.5*v1*dt
		
		v2 = Vinit + 0.5*a1*dt
		a2 = acc(x2, Robj,mobj)

		x3 = Xinit + 0.5*v2*dt
		v3 = Vinit + 0.5*a2*dt
		a3 = acc(x3, Robj,mobj)

		x4 = Xinit + v3*dt
		v4 = Vinit + a3*dt
		a4 = acc(x4, Robj,mobj)

		dxf = (dt/6.0)*(v1 + 2*v2 + 2*v3 + v4)
		dvf = (dt/6.0)*(a1 + 2*a2 + 2*a3 + a4)

		return dxf,dvf
		
		
		
		
					

class CPoint(object):
	def __init__(self,no):
		self._no=no
		self._pos=Vecteur(3)# Vector((0.0,0.0,0.0))
		self._vit=Vecteur(3)# Vector((0.0,0.0,0.0))
		self._masse=1.0
				
		self._charge=0.0
		
		self._typeuh="point"#sphère/cube
		self._dimensions=Vecteur(3)# Vector((0.0,0.0,0.0))
		self._rotation=Vecteur(3)# Vector((0.0,0.0,0.0))

'''
class CObjet(object):
	def __init__(self,nom="Cube"):
		self._nom=nom
		self._obj=bpy.data.objects[self._nom]

	def clef(self,frame=0,typeuh="location"):
		#self._obj.location=self._points[p]._pos
		self._obj.keyframe_insert(typeuh,frame=frame)

	def layer(self,no=0):
		for J in range(20):
			self._obj.layers[J]=False
		self._obj.layers[no]=True 
		
			
class CImage(object):
	def __init__(self,nom='Traj02.png'):
		self._nom=nom
		self._Bimage=bpy.data.images[self._nom]
		im=self._Bimage
		
		self._xmin,self._xmax,self._ymin,self._ymax=-3000,3000,-3000,3000
		self._zmin,self._zmax=-3000,3000
		
		self._larg,self._haut=tuple(im.size)
		self._Xmin,self._Xmax,self._Ymin,self._Ymax=0,self._larg,0,self._haut
		self._pixels=[0.0,0.0,0.0,1.0] * self._larg*self._haut
	

		
	def rToR(self,x,y):
		xmin,xmax,ymin,ymax=self._xmin,self._xmax,self._ymin,self._ymax
		Xmin,Xmax,Ymin,Ymax=self._Xmin,self._Xmax,self._Ymin,self._Ymax
		X=int( (x-xmin)/(xmax-xmin)*(Xmax-Xmin)+Xmin )
		Y=int( (y-ymin)/(ymax-ymin)*(Ymax-Ymin)+Ymin )	
		return (X,Y)	
	
	def colorise(self,i=0,x=0,y=0):
		X,Y=self.rToR(x,y)
		#print(X,Y)
		Xmin,Xmax,Ymin,Ymax=self._Xmin,self._Xmax,self._Ymin,self._Ymax
		larg,haut=self._larg,self._haut
		if (X-Xmin)*(Xmax-X) >0 and (Y-Ymin)*(Ymax-Y)>0: #si dans le cadre
			self._pixels[4*(Y*larg+X)+0],self._pixels[4*(Y*larg+X)+1],self._pixels[4*(Y*larg+X)+2]=couleur(i)
		"""
		if (X-Xmin)*(Xmax-X) >0 and (Y-Ymin)*(Ymax-Y)>0: #si dans le cadre
			if [sortie[4*(Y*larg+X)+0],sortie[4*(Y*larg+X)+1],sortie[4*(Y*larg+X)+2]] == [0.0,0.0,0.0]: #si noir : couleur(i)
				sortie[4*(Y*larg+X)+0],sortie[4*(Y*larg+X)+1],sortie[4*(Y*larg+X)+2]=couleur(i)		 
				sortie[4*(Y*larg+X)+3]=1.0   
			else: #si pas noir : 0.5 ( couleur + couleur(i) )
				a,b,c=couleur(i)
				sortie[4*(Y*larg+X)+0]=0.5*(sortie[4*(Y*larg+X)+0]+a)
				sortie[4*(Y*larg+X)+1]=0.5*(sortie[4*(Y*larg+X)+1]+b)
				sortie[4*(Y*larg+X)+2]=0.5*(sortie[4*(Y*larg+X)+2]+c)
		"""
'''			
		
def couleur(i):
	col=[ (1.0,1.0,1.0) ,(1.0,0.0,0.0),(0.0,1.0,0.0),(0.0,0.0,1.0),(1.0,1.0,0.0),(0.0,1.0,1.0),(1.0,0.0,1.0),(0.5,1.0,0.2)]
	return col[i % len(col)]
					
class CExperience(object):
	def __init__(self,image=[False,'Traj02.png'],blender=[False,"Corps."],fichier=[True,'/tmp/ee']):
		self._DP=CDonneesPhysiques()
		self._ibf={"image":image[0],"blender":blender[0],"fichier":fichier[0]}
		self._dt=0.01
		self._NbDt=25000
		
		self._UneCleToutesLesNPas=1
		self._OBJ_UneCleToutesLesNPas=0
		self._FICH_UneCleTousLesNPas=100
		self._IMAGE_UneCleTousLesNPas=self._UneCleToutesLesNPas
		
		self.initfichier(fichier)
		self.initimage(image)
		
	def initimage(self,image):
		if image[0]==True:
			self._image=CImage(image[1])
			
	
	def initfichier(self,fichier):
		if self._ibf["fichier"]==True:
			self._fich=open('/tmp/ee','w')#open(fichier[1],"w")
			self._html=[]
			self._html+=["self._dt",self._dt]
			self._html+=["self._NbDt",self._NbDt]
			
			
	def TrajectoireTest(self,no=0):
		if no==0:
			dt,NbDt=self._dt,self._NbDt
			self._dt=self._dt*100
			self._NbDt=max(1,int(self._NbDt/100))
			self.Trajectoire()
			self._dt,self._NbDt=dt,NbDt
						
		if no==1:							
			self._OBJ_UneCleToutesLesNPas*=100
			self._FICH_UneCleTousLesNPas*=100
			self._IMAGE_UneCleTousLesNPas*=100
			self.Trajectoire()
			self._OBJ_UneCleToutesLesNPas/=100
			self._FICH_UneCleTousLesNPas/=100
			self._IMAGE_UneCleTousLesNPas/=100
			
					
	def Trajectoire(self):
		N=self._DP._NbDeCorps
		
		
		"""image2
		for ff in range(0,int(self._NbDt/self._UneCleToutesLesNPas)):
			#f=ff*self._UneCleToutesLesNPas
			for tt in range(self._UneCleToutesLesNPas):
				#f=f+1
				self.NouveauPas()
			for i in range(N):
				self._image.colorise(i,self._DP._points[i]._pos[0],self._DP._points[i]._pos[1])
		"""			
		
		
		for f in range(self._NbDt):
			self.NouveauPas()
			
			
			
			"""IMAGE """
			if f % self._IMAGE_UneCleTousLesNPas==0 and self._ibf["image"]==True:
				for i in range(N):
					self._image.colorise(i,self._DP._points[i]._pos[0],self._DP._points[i]._pos[1])
				
				
			
			
			
			""" FICHIER """
			if f % self._FICH_UneCleTousLesNPas==0 and self._ibf["fichier"]==True:
				#print('.',end="")
				for i in range(N):
					self._html+=[str(i)+";pos;"+str(self._DP._points[i]._pos)]
					self._html+=[str(i)+";vit;"+str(self._DP._points[i]._vit)]
			
			#print(self._DP._points[1]._pos.T())
			
			
		""" FICHIER """
		if self._ibf["fichier"]==True:
			for h in self._html:
				print(h,file=self._fich)
			
			self._fich.close()
		
	
		
		"""IMAGE """
		if self._ibf["image"]==True:
			self._image._Bimage.pixels=self._image._pixels#[1.0,0.0,0.0,1.0]*int(len(im.pixels)/4)
			self._image._Bimage.save()


		print('fin trajectoire')
	
	def NouveauPas(self):
		N=self._DP._NbDeCorps
		#dr=[Vector((0.0,0.0,0.0)) for i in range(N)]
		dr=[Vecteur([0.0,0.0,0.0]) for i in range(N)]
		#dv=[Vector((0.0,0.0,0.0)) for i in range(N)]  
		dv=[Vecteur([0.0,0.0,0.0]) for i in range(N)]  
		
		for i in range(N):
			for j in range(N):
				if i != j:
					print(i,j)
					ddr,ddv=self._DP.RK4_XVT(i,j,self._dt)#Xinit, Vinit, a, dt)
					#print(dr[i],dr)
					dr[i] += ddr
					dv[i] += ddv
		exit()			
		#print(ddr)
		
		self.NouveauxPoints(dr,dv) #calcule les nouveau point
		self.TransformePoints() # _NouveauxPoints-> _DP._points
		
	def NouveauxPoints(self,dr,dv):
		N=self._DP._NbDeCorps
		self._NouveauxPoints=[CPoint(c) for c in range(N)]		
		for i in range(N):
			self._NouveauxPoints[i]._pos = self._DP._points[i]._pos + dr[i]
			self._NouveauxPoints[i]._vit = self._DP._points[i]._vit + dv[i]					
		return self._NouveauxPoints			
					
		
			
	def TransformePoints(self):
		N=self._DP._NbDeCorps
		for i in range(N):
			self._DP._points[i]._pos = self._NouveauxPoints[i]._pos
			self._DP._points[i]._vit = self._NouveauxPoints[i]._vit
			
				
'''		
		html=[]				
			
			html+=[i,"pos",self._DP._points[i]._pos]
			html+=[i,"vit",self._DP._points[i]._vit]


	def zTrajectoire(self):
		#for f in range(1,self._Sc._NbDt):
		for ff in range(0,int(self._Sc._NbDt/self._Sc._UneCleToutesLesNFrames)):
			f=ff*self._Sc._UneCleToutesLesNFrames
			for tt in range(self._Sc._UneCleToutesLesNFrames):
				f=f+1
				self.NouveauPas()
			
			fram=int(1.0 * f / self._Sc._UneCleToutesLesNFrames)
			for i in range(self._Sc._NbDeCorps):
				self._points[i]._obj.location=self._points[i]._pos
				self._points[i]._obj.keyframe_insert("location",frame=fram)	
	
	
	
	def zNouveauPas(self):
		dr,dv=[Vector((0.0,0.0,0.0)) for i in range(self._Sc._NbDeCorps)],[Vector((0.0,0.0,0.0)) for i in range(self._Sc._NbDeCorps)]  
		for i in range(self._Sc._NbDeCorps):
			for j in range(self._Sc._NbDeCorps):
				if i != j:
					ddr,ddv=self.RK4_XVT(i,j,self._Sc._dt)#Xinit, Vinit, a, dt)
					#print(dr[i],dr)
					dr[i] += ddr
					dv[i] += ddv
		html=[]			
		for i in range(self._Sc._NbDeCorps):
			self._points[i]._pos += dr[i]
			self._points[i]._vit += dv[i]
			
			html+=[i,"pos",self._points[i]._pos]
			html+=[i,"vit",self._points[i]._vit]
			

	
	
	
	
	
	
	
	
	
	
	
	
	

	
	
	
	
	
	
	def __init__(self,no=0,image=[False,'Traj02.png']):
		if no==1:
			print("3 particules")
			
			
			
			nettoyage()
			
			self.
			
			
			self._Sc=CScene(3 , 1.0/5 , 1.0/160.0 , 320 , 4*16000)
			#  NbDeCorps , G , dt , UneCleToutesLesNFrames , NbDt

		
		
		if no==2:
			print("20 particules")
			nettoyage()
			self._Sc=CScene(20 , 1.0/5 , 1.0/160.0 , 320 , 4*1600)
			#  NbDeCorps , G , dt , UneCleToutesLesNFrames , NbDt
			self._points=[CPoint(c) for c in range(self._Sc._NbDeCorps)]
			masses=[10000.0,1.0,1.0]+[1.0]*50
			for p in range(self._Sc._NbDeCorps):
				self._points[p]._masse=masses[p]
				self._points[p]._pos=Vector((-100*p,0.0,0.0))
				if p !=0:
					self._points[p]._vit=Vector((0.0,(self._Sc._G*masses[0]/(100 *p) )**0.5,0.0))
				if p==0:
					self._points[p]._vit=Vector((0.0,0.0,0.0))	
				self._points[p]._obj.location=self._points[p]._pos
				self._points[p]._obj.keyframe_insert("location",frame=0)
				
				
				
						
				
				

	

						
	




		


class ZCScene(object):
	def __init__(self,NbDeCorps,G,dt,UneCleToutesLesNFrames,NbDt):
		self._NbDeCorps,self._G,self._dt,self._UneCleToutesLesNFrames,self._NbDt=NbDeCorps,G,dt,UneCleToutesLesNFrames,NbDt
		self.affichage()
	def affichage(self):
		print("temps total ="+str(self._dt)+" * "+str(self._NbDt)+" = "+str(self._dt*self._NbDt))
		print("frame totale ="+str(self._NbDt/self._UneCleToutesLesNFrames))
		scene.frame_end=self._NbDt/self._UneCleToutesLesNFrames
		scene.objects['Text'].data.body="Temps par frame :\n"+str(self._dt*self._UneCleToutesLesNFrames)
		


	  

def nettoyage(nb=50):
	for i in range(nb):
		nom='Corps.'+str(i).zfill(3)
		objets=[o.name for o in scene.objects]
		if nom in objets:
			scene.objects[nom].location=Vector((0.0,0.0,0.0))
			scene.objects[nom].keyframe_insert("location",frame=0)
			layer(scene.objects[nom],1)


























					
					
			self._dt=1.0
			
			
			
			self._UneCleToutesLesNFrames=1
			self._NbDt=250




			
		self.affichage()
		
		
		
		
	def affichage(self):
		print("temps total ="+str(self._dt)+" * "+str(self._NbDt)+" = "+str(self._dt*self._NbDt))
		print("frame totale ="+str(self._NbDt/self._UneCleToutesLesNFrames))
		scene.frame_end=self._NbDt/self._UneCleToutesLesNFrames
		scene.objects['Text'].data.body="Temps par frame :\n"+str(self._dt*self._UneCleToutesLesNFrames)
		
		
		





'''	
global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	z=CExperience()
	z.Trajectoire()
	
	sys.exit()
